;----------------------;
;--Main-Script-Editor--;
;----------------------;

Graphics 800, 600, 16, 2
SetBuffer BackBuffer()

AppTitle "FruitSurvive - Editor"
SeedRnd MilliSecs()

Global Timer = CreateTimer(60)

Include "scripts\editor\menubar by addi.bb"
Include "scripts\editor\blitzui demo by addi.bb"
Include "scripts\multi types.bb"

;------------------------------------------------------------Erstellen der Menbar-------------------------------------------------------------;

Global MenuBar	  = CreateMenuBar()

Global File   	  = CreateMenuBarTitel("Datei", MenuBar)
Global MenNew	  = CreateTitelItem("Neu", File)
Global MenOpen	  = CreateTitelItem("ffnen", File)
Global MenSave	  = CreateTitelItem("Speichern", File)
Global MenClear	  = CreateTitelItem("Leeren", File)
Global MenAppExit = CreateTitelItem("Ende", File)

Global MenProb  = CreateMenuBarTitel("Bearbeiten", MenuBar)
Global MenOpen2	= CreateTitelItem("Gre", MenProb)

Global View     = CreateMenuBarTitel("Ansicht", MenuBar)
Global MenGrid  = CreateTitelItem("Gitter", View)
Global MenMinMa = CreateTitelItem("MiniMap", View)

;------------------------------------------------------------Erstellen der Fenster-------------------------------------------------------------;

Global WinOpMap    = CreateWindow	("Open Map", 200, 150, 350, 200, False)	  ;Ladefenster
Global Load_Lbl    = CreateLabel	("Whlen sie eine Map", 15, 15, WinOpMap) ;Label frs Ladefenster
Global ComboBox    = CreateComboBox (200, 10, 120, 20, WinOpMap)			  ;Combobox in welche die Mapnamen gesetzt werden
Global Cancel_Butt = CreateButton   ("Cancel", 20, 40, 100, 20, WinOpMap)	  ;Cancelbutton
Global Ok_Butt 	   = CreateButton   ("Ok", 20, 65, 100, 20, WinOpMap)		  ;Okbutton

Global WinSetLevel  = CreateWindow ("Set Level", 300, 200, 200, 100, False)
Global SetLevel_Lbl = Createlabel  ("Ab welchem Level", 15, 15, WinSetLevel)
Global TextBox	    = CreateTextBox(15, 30, 50, 20, WinSetLevel)
Global Set_Butt     = CreateButton ("Ok", 15, 55, 100, 20, WinSetLevel)

Global WinSetSwitch  = CreateWindow ("Set Switch", 300, 200, 200, 100, False)
Global SetSwitch_Lbl = Createlabel  ("Ab wievielen Points", 15, 15, WinSetSwitch)
Global TextBox2	     = CreateTextBox(15, 30, 50, 20, WinSetSwitch)
Global Set_Butt2     = CreateButton ("Ok", 15, 55, 100, 20, WinSetSwitch)

Global WinSetSize = CreateWindow ("Set Size", 250, 200, 300, 200, False)
Global Width_Lbl  = Createlabel  ("Wie viele Blocks in X-Richtung", 15, 15, WinSetSize)
Global Width_TB	  = CreateTextBox(15, 35, 100, 20, WinSetSize)
Global Heigth_Lbl = Createlabel  ("Wie viele Blocks in Y-Richtung", 15, 60, WinSetSize)
Global Heigth_TB  = CreateTextBox(15, 80, 100, 20, WinSetSize)
Global Set_Butt3  = CreateButton ("Ok", 100, 130, 100, 20, WinSetSize)

;----------------------------------------------------------------Sonstige Vars-----------------------------------------------------------------;

;Variablen
Global Grid
Global MiniMap

Global ScrX
Global ScrY

Global MapMaxX = 48
Global MapMaxY = 36

Global TileSektion
Global CurrTile = 1

;Spawnpoint Variablen
Global SpawnID
Global SetSpawnLevel
Global TotalSpawnPoints

;Schalter
Global SetDoorPos
Global SwitchID
Global TotalSwitch

;Player Spawnpoint
Global PlayerX
Global PlayerY
Global PlayerS

;Zwischenspeichern des Mapnamen
Global SaveName$

;Bild laden
Global TS = 1

Global Tileset = LoadAnimImage("gfx\tilesets\tileset"+TS+".png", 32, 32, 0, 27)
MaskImage Tileset, 255, 0, 255

;Die Map dimensionieren
Dim Map(MapMaxX, MapMaxY)

;Maps in Combobox lesen
Dir = ReadDir("maps\")
While True
	TempF$ = NextFile$(Dir)
	If TempF$="" Then
		Exit
	Else If Left(TempF$, 1)<>"." Then
		AddComboBoxItem(TempF$, ComboBox)
	End If
Wend

;----------------------------------------------------------------Hauptschleife-----------------------------------------------------------------;

ClsColor 0, 0, $FF00FF

While Not KeyHit(1)
	Cls
	
	TempMouseX = MouseX()
	TempMouseY = MouseY()
	
	MouseState = False
	If MouseHit(1) Then MouseState = 1:FlushMouse
	If MouseHit(2) Then MouseState = 2:FlushMouse
	
	;Scrollen
	If KeyDown(205) Then ScrX = ScrX+8
	If KeyDown(203) Then ScrX = ScrX-8
	
	If KeyDown(200) Then ScrY = ScrY-8
	If KeyDown(208) Then ScrY = ScrY+8
	
	;Tiles mit Mausrad whlen
	Select MouseZSpeed()
	Case -1
		If CurrTile>TileSektion*8+1 Then CurrTile = CurrTile-1		
	Case 1
		
		If TileSektion<>2 Then
			If CurrTile<TileSektion*8+8 Then CurrTile = CurrTile+1
		Else
			If CurrTile<TileSektion*8+11 Then CurrTile = CurrTile+1
		End If
		
	End Select
	
	;--------------------------------------------------------------------------;

	;Map und Tilebar und Gegner-Spawnpoints zeichnen
	DrawMap()
	DrawSpawnPoints()
	DrawSwitches()
	DrawTilebar()

	;Felder setzen und oder lschen
	If (TempMouseY-20+ScrY)/32>-1 And (TempMouseY-20+ScrY)/32<MapMaxY+1 And (TempMouseX+ScrX)/32>-1 And (TempMouseX+ScrX)/32<MapMaxX+1 And WindowAktiv()=False And TitelSelected()=False Then
			
		If SetDoors=True Then
			Rect (TempMouseX+ScrX)/32*32-ScrX, (TempMouseY+ScrY-20)/32*32+20-ScrY, 32, 32, False
			If MouseState=1 And Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32)>0 And Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32)<19 Then 
				Sw.Switch = Object.Switch(SwitchID)
				Sw\DoorX  = (TempMouseX+ScrX)/32
				Sw\DoorY  = (TempMouseY-20+ScrY)/32
				 
				EnDisableGadjet(WinSetSwitch, True)
			End If
		Else
		
			DrawImage Tileset, (TempMouseX+ScrX)/32*32-ScrX, (TempMouseY+ScrY-20)/32*32+20-ScrY, CurrTile-1
			
			;Normalen Tiles
			If CurrTile<25 Then
				If TempMouseY>19 And TempMouseY<567 And MouseState=1 Then Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32)=CurrTile
				If TempMouseY>19 And TempMouseY<567 And MouseState=2 Then Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32)=0
			End If
			
			;------------------------------------------------;
			
			If MouseState=1 And Map((TempMouseX+ScrX)/32, (TempMouseY-20+ScrY)/32)=0 Then
				;Schalter setzen
				If CurrTile=27 Then
					SetDoors = True
				
					Sw.Switch = New Switch
					Sw\X      = (TempMouseX+ScrX)/32
					Sw\Y	  = (TempMouseY-20+ScrY)/32
					
					SwitchID 	= Handle(Sw)
					TotalSwitch = TotalSwitch+1
				End If
				
				;------------------------------------------------;
				
				;Playerposition setzen oder lschen
				If CurrTile=25 Then
					PlayerX = (TempMouseX+ScrX)/32*32
					PlayerY = (TempMouseY-20+ScrY)/32*32
					PlayerS = True
				End If
								
				;------------------------------------------------;
				
				;Spawnpoints setzen oder lschen
				If CurrTile=26 Then
					S.SpawnPoint = New SpawnPoint
					
					S\ID = 1
					S\X  = (TempMouseX+ScrX)/32
					S\Y  = (TempMouseY-20+ScrY)/32
								
					SpawnID = Handle(S)
					
					TotalSpawnPoints = TotalSpawnPoints+1
					
					EnDisableGadjet(WinSetLevel, True)			
				End If
			End If
			
			;Nicht Tiles auf der Map lschen
			If MouseState=2 Then 
				
				;Schalter an Mausposition finden und lschen
				For Swi.Switch=Each Switch
					If (TempMouseX+ScrX)/32=Swi\X And (TempMouseY-20+ScrY)/32=Swi\Y Then Delete Swi:TotalSwitch = TotalSwitch-1:Exit
				Next
								
				;Playerposition lschen
				If CurrTile=25 Then
					PlayerX = 0
					PlayerY = 0
					PlayerS = False
				End If
				
				;Spawnpoint an Mausposition finden und lschen
				For S.SpawnPoint = Each SpawnPoint
					If (TempMouseX+ScrX)/32=S\X And (TempMouseY-20+ScrY)/32=S\Y Then Delete S:TotalSpawnPoints = TotalSpawnPoints-1:Exit
				Next	
			End If
			
		End If
	End If
		
	;Player-Spawnpoint zeichnen
	If PlayerS=True Then Rect PlayerX-ScrX, PlayerY+20-ScrY, 32, 32	
	
	;--------------------------------------------------------------------------;
	
	;Menbar und Windows rendern
	RenderMenuBar()
	RenderWindow()
	
	;Checken ob ein Menbarunterpunkt geklickt wurde
	Select CheckEvent()
	Case MenNew
		SaveName=""
		ClearMap()
	
	Case MenOpen
		EnDisableGadjet(WinOpMap, True)
	
	Case MenSave	
		SaveMap()
	
	Case MenClear
		ClearMap()
	
	Case MenAppExit
		End
	
	Case MenGrid
		Grid = True-Grid
	
	Case MenMinMa
		MiniMap = True-MiniMap
	
	Case MenOpen2
		EnDisableGadjet(WinSetSize, True)	
	End Select
	
	;Buttonevents checken	
	Select GetEvents("BUTTON")
	Case Cancel_Butt
		EnDisableGadjet(WinOpMap, False)
	
	Case Ok_Butt
		EnDisableGadjet(WinOpMap, False)
		If GetComboBoxText(ComboBox)>"" Then LoadMap("maps\"+GetComboBoxText(ComboBox))
	
	Case Set_Butt
		S.SpawnPoint  = Object.SpawnPoint(SpawnID)
		S\Le 		  = Int(GetTextBoxText(TextBox))
		
		EnDisableGadjet(WinSetLevel, False)
	Case Set_Butt2
		Sw.Switch = Object.Switch(SwitchID)
		Sw\Coasts = Int(GetTextBoxText(TextBox2))
				
		SetDoors = False
		EnDisableGadjet(WinSetSwitch, False)
	
	Case Set_Butt3
		
		MapMaxX = Int(GetTextBoxText(Width_TB))
		MapMaxY = Int(GetTextBoxText(Heigth_TB))
		
		ClearMap()
		EnDisableGadjet(WinSetsize, False)
	
	End Select
	
	WaitTimer Timer
	Flip(0)
Wend

;------------------------------------------------------------------Funktionen------------------------------------------------------------------;

Function DrawMap()
	
	;Normale Map zeichnen
	Color 0,0,$FFFFFF
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			If Map(X,Y)>0 Then 				
				
				DrawImage TileSet, X*32-ScrX, Y*32+20-ScrY, Map(X,Y)-1
			Else If Grid=True
				
				Rect X*32-ScrX, Y*32+20-ScrY, 33, 33, False
			End If
		Next
	Next
	
	;Minimap wird gezeichnet
	If MiniMap = True Then 
		Rect 800-MapMaxX*2-4, 22, MapMaxX*2+2, MapMaxY*2+2, True
	
		Color 0, 0, $FF0000
		For Y=0 To MapMaxY
			For X=0 To MapMaxX		
				If Map(X, Y)>0 Then Rect 800-MapMaxX*2-4+X*2, 22+Y*2, 2, 2, True
			Next
		Next
	
		Color 0, 0, $00FF00
		Rect 800-MapMaxX*2-4 +(ScrX/32)*2, 22 +(ScrY/32)*2, 25*2, 17*2, False
		Color 0, 0, $FFFFFF
	End If
End Function

;--------------------------------------------------------------------;

;Zeichnet die Tileauswahl
Function DrawTilebar()
	Color 0, 0, $D2D2D2
	Rect 0, 567, 800, 33, True
	Color 0, 0, $A2A2A2
	Line 0, 567, 800, 600-33
	
	For X=0 To 16 Step 8
		DrawImage Tileset, 32*C, 600-32, X
		If RectsOverlap(TempMouseX, TempMouseY, 1, 1, 32*C, 568, 31, 32) And MouseState=1 Then TileSektion = C: CurrTile = C*8+1
		C=C+1
	Next	
	
	Color 0, 0, $0000FF
	Rect TileSektion*32, 600-32, 32, 32, False
End Function

;--------------------------------------------------------------------;

;Alle erstellten Gegner-Spawnpoints zeichnen
Function DrawSpawnPoints()
	For S.SpawnPoint=Each SpawnPoint
		DrawImage Tileset, S\X*32-ScrX, S\Y*32-ScrY+20, 25
	Next
End Function

;--------------------------------------------------------------------;

;Alle erstellten Schater zeichnen
Function DrawSwitches()
	For S.Switch=Each Switch
		Color 0, 0, $00FF00
		Rect S\DoorX*32-ScrX, S\DoorY*32-ScrY+20, 32, 32, False
		Color 0, 0, $0000FF
		Rect S\X*32-ScrX, S\Y*32-ScrY+20, 32, 32, False		
	Next
End Function

;--------------------------------------------------------------------;

;Map speichern
Function SaveMap()
	Local C
	Local F$
	
	If SaveName$="" Then
		While True
			If FileType("maps\map"+C+".map")=False Then F$="maps\map"+C+".map":Exit
			C = C+1
		Wend
	Else
		F$=SaveName$
	End If
		
	FileOut=WriteFile(F$)
	
	;Map Sicherheitszeile
	WriteString FileOut, "Map fuer FruitSurvive"
	
	;Map gre
	WriteInt FileOut, MapMaxX
	WriteInt FileOut, MapMaxY
	
	;Benutztes Tileset
	WriteByte FileOut, TS
	
	;Playerposition
	WriteInt  FileOut, PlayerX
	WriteInt  FileOut, PlayerY
	WriteByte FileOut, PlayerS
	
	;Mapdaten
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			WriteByte FileOut, Map(X, Y)
		Next
	Next
	
	;Spawnpoints
	WriteByte FileOut, TotalSpawnPoints
	For S.SpawnPoint=Each SpawnPoint
		WriteByte FileOut, S\ID
		WriteInt  FileOut, S\X
		WriteInt  FileOut, S\Y
		WriteByte FileOut, S\Le
	Next
	
	;Schalter
	WriteByte FileOut, TotalSwitch
	For Sw.Switch=Each Switch
		WriteInt FileOut, Sw\DoorX
		WriteInt FileOut, Sw\DoorY
		WriteInt FileOut, Sw\X
		WriteInt FileOut, Sw\Y
		WriteInt FileOut, Sw\Coasts
	Next
	
	CloseFile FileOut
End Function

;--------------------------------------------------------------------;

;Map laden
Function LoadMap(F$)
	
	For S.SpawnPoint=Each SpawnPoint
		Delete S
	Next
	
	For Sw.Switch=Each Switch
		Delete Sw
	Next
	
	FileIn = OpenFile(F$)
	
	;berprfen ob die Map zum Spiel gehhrt
	If Not ReadString(FileIn)="Map fuer FruitSurvive" Then RuntimeError "Falscher Maptyp"
	
	;Karten gre
	MapMaxX = ReadInt(FileIn)
	MapMaxY = ReadInt(FileIn)
	Dim Map(MapMaxX, MapMaxY)
	
	;Zu nutzendes Tileset
	TS = ReadByte(FileIn)
	FreeImage Tileset
	Tileset = LoadAnimImage("gfx\tilesets\tileset"+TS+".png", 32, 32, 0, 27)
	MaskImage Tileset, 255, 0, 255
	
	;Playerposition
	PlayerX = ReadInt (FileIn)
	PlayerY = ReadInt (FileIn)
	PlayerS = ReadByte(FileIn)
	
	;Karte
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			Map(X, Y) = ReadByte(FileIn)
		Next
	Next
	
	;Spawnpoints
	TotalSpawnPoints = ReadByte(FileIn)
	For X=0 To TotalSpawnPoints-1
		S.SpawnPoint = New SpawnPoint
			
		S\ID = ReadByte(FileIn)
		S\X  = ReadInt (FileIn)
		S\Y  = ReadInt (FileIn)
		S\Le = ReadByte(FileIn)
	Next
	
	;Schalter
	TotalSwitch = ReadByte(FileIn)
	For X=0 To TotalSwitch-1
		Sw.Switch= New Switch
		
		Sw\DoorX = ReadInt(FileIn)
		Sw\DoorY = ReadInt(FileIn)
		Sw\X	 = ReadInt(FileIn)
		Sw\Y	 = ReadInt(FileIn)
		Sw\Coasts= ReadInt(FileIn)
	Next
	
	;Datei schlieen und merken
	CloseFile(FileIn)
	SaveName$ = F$
End Function

;--------------------------------------------------------------------;

;Map leeren
Function ClearMap()
	Dim Map(MapMaxX, MapMaxY)
	
	For S.SpawnPoint=Each SpawnPoint
		Delete S
	Next
	
	For Sw.Switch=Each Switch
		Delete Sw
	Next
End Function