;|---------------------------------|
;|----Button-Funktionen-by-Addi----|
;|---------------------------------|

Type Button
	Field X
	Field Y
	Field Width
	Field Height
	Field Pic
	Field Enabled
	Field Clicked
	Field Cap$
	Field BType
End Type

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Neuen Bilder-Button erstellen
Function CreateImageButton(X,Y,W,H,Pic$,E)
	B.Button  = New Button
	B\X		  = X
	B\Y		  = Y
	B\Width	  = W
	B\Height  = H
	B\Pic	  = LoadAnimImage(Pic$,W,H,0,2)
	B\Enabled = E
	B\Clicked = False
	B\BType	  = 1
	
	MaskImage B\Pic,255,0,255
	Return Handle(B)
End Function

;Neuen Text-Button erstellen
Function CreateTextButton(X,Y,W,H,Cap$,E)
	B.Button  = New Button
	B\X		  = X
	B\Y		  = Y
	B\Width	  = W
	B\Height  = H
	B\Cap$	  = Cap$
	B\Enabled = E
	B\Clicked = False
	B\BType   = 2

	Return Handle(B)
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Diese Funktion akktualisiert alle ImageButton
Function UpdateImageButton()
	For B.Button=Each Button
		If B\Enabled And B\BType=1 Then
			
			DrawImage B\Pic,B\X,B\Y,0
			
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, B\X, B\Y, B\Width, B\Height) Then
				DrawImage B\Pic,B\X,B\Y,1
				If MouseState Then B\Clicked=True
			End If
			
		End If	
	Next
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Buttonstate berprfen
Function GetButtonState(ID)
	B.Button = Object.Button(ID)
	If B\Clicked=True And B\BType=1 Then B\Clicked = False:Return True
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

;Ein/Ausschalten der Buttons
Function DeAktivButton(ID,E)
	B.Button=Object.Button(ID)
	B\Enabled = E
End Function

Function DeAktivAllButton(E)
	For B.Button=Each Button
		B\Enabled = E
	Next
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------

Function DestroyAllButtons()
	For B.Button=Each Button
		Delete B
	Next
End Function

;-----------------------------------------------------------------------------------------------------------------------------------------------
;Funktionen nur eingefgt um eine fr das Spiel bentigte Funktion zu nutzen

Function UpdateTextButton()
	For B.Button=Each Button
		If B\Enabled=True And B\BType=2 Then
			
			Color 0, 0, $D2D2D2
			Rect B\X, B\Y, B\Width, B\Height, True
			Color 0, 0, $000000
			Rect B\X, B\Y, B\Width, B\Height, False
			
			Text B\X+B\Width/2, B\Y+B\Height/2, B\Cap$, True, True
			
			Color 0, 0, $646464
			If Not RectsOverlap(TempMouseX, TempMouseY, 1, 1, B\X, B\Y, B\Width, B\Height) Then
				Line B\X+1, B\Y+B\Height-2, B\X+B\Width-2, B\Y+B\Height-2
				Line B\X+B\Width-2, B\Y+1, B\X+B\Width-2, B\Y+B\Height-2
			Else
				Line B\X+1, B\Y+1, B\X+B\Width-2, B\Y+1
				Line B\X+1, B\Y+1, B\X+1, B\Y+B\Height-2
				
				;Buttontitel zurckliefern
				If MouseState=1 Then B\Clicked=True
			End If
			
		End If
	Next
End Function

Function EnableTextButton(E)
	For B.Button = Each Button
		If B\BType=2 Then B\Enabled = E
	Next
End Function

Function GetTextButtonText$()
	For B.Button=Each Button
		If B\BType=2 Then 
			If B\Clicked=True Then B\Clicked=False:Return B\Cap$
		End If
	Next	
End Function