Global main_window,canvas,time_check,open,score_field,gfx_grass,gfx_grass2,gfx_grass3,gfx_cherry,gfx_snake,time_field,name_field,tile_listbox,map_save,levelpack_listbox,fieldsize=28,tilesize=20,dir=0,mx,my,mh
start_gui()
Dim map(fieldsize,fieldsize)
For x=0 To fieldsize
	For y=0 To fieldsize
		map(x,y)=3
	Next
Next 

SetBuffer CanvasBuffer(canvas)

gfx_cherry=LoadImage("gfx\cherry.png")
gfx_snake=LoadImage("gfx\snake.png")
gfx_grass=LoadImage("gfx\grass.png")
gfx_grass2=LoadImage("gfx\grass2.png")
gfx_grass3=LoadImage("gfx\grass3.png")

load_mappacks()

Repeat
	Cls 
	
	mx = MouseX(canvas)
	my = MouseY(canvas)
	mh = MouseHit(1)
	md = MouseDown(1)
	mh2= MouseHit(2)
	
	If mh Or md
		xmap=mx/tilesize
		ymap=my/tilesize
		If xmap=<fieldsize And ymap=< fieldsize And xmap>0 And ymap>0
			map(xmap,ymap)=get_tile_id%()
		EndIf 
	EndIf 
	
	If mh2
		xmap=mx/tilesize
		ymap=my/tilesize
		If xmap=<fieldsize And ymap=< fieldsize And xmap>0 And ymap>0
			map(xmap,ymap)=123 ; PLAYER START
		EndIf 
	EndIf 		
	
   If KeyHit(1) Then End 
   WaitEvent(500)
   Select EventID()
      Case $803
         End
      Case $401
		Select EventSource()
			Case time_check
				If ButtonState(time_check)=0 Then DisableGadget(time_field):EnableGadget(score_Field)
				If ButtonState(time_check)=1 Then EnableGadget(time_field):DisableGadget(score_Field)
			Case map_save
				return_code=save_map(TextFieldText(name_field))
				Select return_code
					Case -10
						Notify "no filename provided"
				End Select
			Case open
				load_map(RequestFile("Choose File","map"))
				
		End Select 
   End Select
	render()
Forever







Function load_map(filename$)
	full_filename$=filename$
	file=OpenFile(full_filename$)
	If file =0 Then RuntimeError "MAPFILENOTFOUND  , FILETYPE:"+FileType(full_filename$)
	
	player_start_x=0
	player_start_y=0
	map_time=-1
	score=0
	fruits_total=0
	
	
	For x=0 To fieldsize
		For y=0 To fieldsize
			map(x,y)=0
		Next
	Next 
	
	

	
	
	
	
	While Not Eof(file)
	   	strng$=ReadLine(file)
		
		If Not Left(strng$,1)="#" ;IGNORE COMMENTS
			sign1=Instr(strng$,",")
			sign2=Instr(strng$,",",sign1+1)
			strng_len%=Len(strng$)
			x=Left(strng$,sign1)
			y=Mid(strng$,sign1+1,strng_len%-sign1-strng_len%-sign2)
			p_typ$=Right(strng$,strng_len%-sign2)
			
			Select Lower(p_typ$)
				Case "block"
					map(x,y)=-1
				Case "snake"
					player_start_x=x
					player_start_y=y
				Case "time"
					map_time=x
					SetGadgetText time_Field,x
				Case "grass"
					map(x,y)=3
				Case "grass2"
					map(x,y)=4
				Case "grass3"
					map(x,y)=5
				Case "score"
					If x<>0
						SetGadgetText score_field,x
					EndIf
			End Select
			
			If Instr(p_typ$,Lower("fruit")) >0 
				map(x,y)=Int(Right(p_typ$,1))
				fruits_total=fruits_total+1
			EndIf 
		EndIf 
			
	Wend 
	

End Function 













Function get_tile_id%()
	Local selected_tile_name$
	selected_tile_name$=GadgetItemText$(tile_listbox,SelectedGadgetItem(tile_listbox))
	Select selected_tile_name$
		Case "block"
			Return -1
		Case "air"
			Return 0
		Case "cherry"
			Return 2
		Case "grass:1"
			Return 3
		Case "grass:2"
			Return 4
		Case "grass:3"
			Return 5
		Default
			RuntimeError "invalid tile id: "+selected_tile_name$
	End Select
End Function
	


Function save_map(filename$)
	If filename$="" Return -10
	
	mappack$=GadgetItemText$(levelpack_listbox,SelectedGadgetItem(levelpack_listbox))
	If FileType("maps/"+mappack$+"/"+filename$+".map")=1
		feedback=Proceed("Overwrite map? "+filename$,1)
		If feedback<>1 Then Return feedback
	EndIf 
	
	
	savefile=WriteFile("maps/"+mappack$+"/"+filename$+".map")
	For x=1 To fieldsize
		For y=1 To fieldsize
			Select map(x,y)
				Case -1
					WriteLine savefile,x+","+y+",block"
				Case 2
					WriteLine savefile,x+","+y+",fruit:2"
				Case 123
					WriteLine savefile,x+","+y+",snake"
				Case 3 
					WriteLine savefile,x+","+y+",grass"
				Case 4
					WriteLine savefile,x+","+y+",grass2"
				Case 5 
					WriteLine savefile,x+","+y+",grass3"
			End Select 
		Next
	Next
	If ButtonState(time_check)=1
		t_time=TextFieldText$(time_field) 
		If t_time=0 Then Notify "no time set, making it default (100)":t_time=100
		WriteLine savefile,t_time+","+t_time+",time"
	EndIf 
	WriteLine savefile,TextFieldText$(score_field)+","+TextFieldText$(score_field)+",score"
	CloseFile (savefile)
	Notify ("map saved!")
End Function 




Function load_mappacks()
	map_packs=0
	
	map_dir=ReadDir("maps/")
	Repeat
		dir_cont$=NextFile$(map_dir)
		If dir_cont$="" Then Exit 
		If FileType("maps/"+dir_cont$)=2 And  (Not(dir_cont$<>"." Xor dir_cont$<>".."))
			AddGadgetItem levelpack_listbox,dir_cont$
		EndIf 
	Forever
	CloseDir(map_dir)
	SelectGadgetItem(levelpack_listbox,0)
End Function



Function start_gui()
	main_window=CreateWindow("Snake-Editor",80,80,800,750,Desktop(),1)
	canvas=CreateCanvas(0,0,800,600,main_window)
	
	
	option_panel=CreatePanel(5,605,225,115,main_window,1)
	
	time_check=CreateButton("Time-Trial?",5,0,85,22,option_panel,2)
	time_field=CreateTextField(5,30,35,22,option_panel)
	score_field=CreateTextField(5,60,35,22,option_panel)
	DisableGadget(time_field)
	
	
	CreateLabel("Tile:",100,5,20,19,option_panel)
	tile_listbox=CreateListBox(100,24,100,100,option_panel)
	AddGadgetItem tile_listbox,"block",1
	AddGadgetItem tile_listbox,"air"
	AddGadgetItem tile_listbox,"cherry"
	AddGadgetItem tile_listbox,"grass:1"
	AddGadgetItem tile_listbox,"grass:2"
	AddGadgetItem tile_listbox,"grass:3"
	
	CreateLabel("Mappack:",310,610,50,19,main_window)
	levelpack_listbox=CreateListBox(310,630,100,50,main_window)
	
	
	CreateLabel("Filename:",480,610,50,19,main_window)
	name_field=CreateTextField(480,630,95,22,main_window)
	map_save=CreateButton("Save",480,660,95,22,main_window,1)


	open=CreateButton("Open",620,660,95,22,main_window,1)


End Function 






Function render()

	Text 0,0,"SCORE: "+score
	If map_time<>-1
		Text 0,20,"TIME: "+map_time
	EndIf
	


	For x=1 To fieldsize
		For y=1 To fieldsize
			If (x=fieldsize/2 Or x=fieldsize/2+1) Or (y=fieldsize/2 Or y=fieldsize/2+1)
				Color 100,120,140
			Else
				Color 255,255,255
			EndIf 
			Rect x*tilesize,y*tilesize,tilesize,tilesize,0
			Select map(x,y)
				Case -1
					Color 255,255,0
					Rect x*tilesize,y*tilesize,tilesize,tilesize,1
					Color 255,255,255
				Case 2
					DrawImage gfx_cherry,x*tilesize,y*tilesize
				Case 123
					DrawImage gfx_snake,x*tilesize,y*tilesize
				Case 3
					DrawImage gfx_grass,x*tilesize,y*tilesize
				Case 4
					DrawImage gfx_grass2,x*tilesize,y*tilesize
				Case 5
					DrawImage gfx_grass3,x*tilesize,y*tilesize
			End Select 
		Next
	Next 
	
	FlipCanvas (canvas)
End Function 