;ozzi789 - BCC # 61
Global fieldsize=28,tilesize=20,gamemodes$,gamemode=2,fontbig,fontsmall
Global map_score,map_time_total,map_time_start,snake_lenght=10,mpointer=0
Global timer,growthtime,  score,map_time,current_map=1,mappackover
Global lastdir,dir=0,fruits_total=0,last_move_time, player_start_x, player_start_y,old_dir
Global gfx_grass,gfx_grass2,gfx_grass3,gfx_mesg,gfx_cherry,gfx_background,gfx_pear,gfx_tail_s,gfx_wall,gfx_tail_w 

Dim map(fieldsize,fieldsize)
Const cherry=2,pear=6,block=-1,appname$="Fruitysnake"

Type snake
	Field x
	Field y
	Field sdir
End Type

Type key_queue
	Field dir
End Type 

Dim head(4)
Dim tail(4)
Dim tailend(4)


load_res()



While Not KeyHit(1)
	menu()
Wend

End 


Function draw_menu_gfx()
	SetFont(fontbig)
	DrawImage gfx_grass2,30,65
	DrawImage gfx_grass2,530,365
	DrawImage gfx_grass2,120,265
	DrawImage gfx_grass2,403,485
	DrawImage gfx_grass2,520,25
	DrawImage gfx_grass3,490,140
	DrawImage gfx_grass3,123,10
	DrawImage gfx_grass3,623,394
	DrawImage gfx_grass3,223,191
	DrawImage gfx_grass3,34,404
	DrawImage gfx_grass3,454,504
	
	DrawImage gfx_mesg,300,80
	Color 255,255,0
	Text 355,122,appname$
	Color 255,255,255
	
	Text 400,240,"Play "+gamemodes$,1,0
	Text 400,280,"Help",1,0
	Text 400,320,"End",1,0
	SetFont(fontsmall)
	Text 400,400,"Use Arrow Keys and Enter to navigate",1,1
	
	DrawImage head(3),300,mpointer*40+240
	DrawImage gfx_tail_w,280,mpointer*40+240
	DrawImage tailend(3),260,mpointer*40+240
End Function 


Function menu_keyboard()
	If KeyHit(200) Then mpointer=mpointer-1
	If KeyHit(208) Then mpointer=mpointer+1
	If KeyHit(205) Then gamemode=gamemode+1
	If KeyHit(203) Then gamemode=gamemode-1
	
	If mpointer<0 Then mpointer=2
	mpointer=Abs(mpointer Mod 3)

	If gamemode<0 Then gamemode=2
	gamemode=Abs(gamemode Mod 3)

	Select gamemode
		Case 0
			gamemodes$=": Time-trial"
		Case 1
			gamemodes$=": Point-trial"
		Case 2
			gamemodes$=": Classic"
	End Select 
End Function 

Function menu()
	current_map=1
	Cls
	draw_menu_gfx()
	menu_keyboard()

	If KeyHit(28)
		Select mpointer
			Case 0
				load_map(current_map)
				game()
			Case 1
				help()
			Case 2
				End 
		End Select
	EndIf  
	
	WaitTimer timer
	Flip 0

End Function


Function help()
	Cls
	SetFont(fontbig)
	FlushKeys()
	DrawImage gfx_background,0,0
	Text 20,20,Chr(27)
		DrawImage head(2),40,20
		DrawImage gfx_tail_w,60,20
		DrawImage tailend(2),80,20	
	Text 20,60,Chr(26)
		DrawImage head(3),80,60
		DrawImage gfx_tail_w,60,60
		DrawImage tailend(3),40,60	
	Text 140,20,Chr(24)
		DrawImage head(1),160,20
		DrawImage gfx_tail_s,160,40
		DrawImage tailend(1),160,60	
	Text 220,20,Chr(18)
		DrawImage head(0),240,60
		DrawImage gfx_tail_s,240,40
		DrawImage tailend(0),240,20
	Text 360,20,"1 Point"
		DrawImage gfx_pear,320,20
	Text 360,60,"10 Points"
		DrawImage gfx_cherry,320,60

	Text 20,120,"Time-Trial: Eat all the fruit before the time runs out"
	Text 20,140,"Point-Trial: Try to complete the objectives"				
	Text 20,160,"Classic: Eat as much as you can, before you eventually fail"
	Text 20,180,"Use F12 to advance a level if you are stuck ;) "
		
	Text 20,220,"[ESC] to quit - Press any key to get back"
	Flip
	WaitKey 
	
End Function


Function game()
	While Not KeyHit(1) 
		Cls
		nofruit()
		keyboard()	
		check_for_win()
		render()
		move_snake()	
		
		If KeyHit(88)
				Select gamemode
					Case 0
						mapfolder$="timetrial"
					Case 1
						mapfolder$="pointtrial"
					Case 2
						mapfolder$="classic"
				End Select
				full_filename$="maps\"+mapfolder$+"\"+Int(current_map+1)+".map"
				file=OpenFile(full_filename$)
				If file <>0		
					current_map=current_map+1	
					load_map(current_map)		
				EndIf
				CloseFile(file)
		EndIf 
		
		If mappackover=1
			mappackover=0
			Return
		EndIf 	
	Wend
	FlushKeys()
End Function




Function check_for_win()
	
	Select gamemode
		Case 0
			map_time%=map_time_total-(MilliSecs()-map_time_start)/1000
			If map_time%=0
				game_over("You ran out of time!",0)
			EndIf 
			If fruits_total=0 And gamemode<>1
				game_over("Level completed!",1)
			EndIf 
		Case 1
			If score = map_score Then game_over("Level completed!",1)
	End Select
	
End Function

Function nofruit()
	Local count
	If gamemode=1 Or gamemode=2
		count=0
		For x=1 To fieldsize
			For y=1 To fieldsize
				If map(x,y)=pear
					count=count+1
				EndIf	
			Next
		Next	
		If count=0 Then spawn_fruit()
	EndIf
End Function

Function spawn_fruit()
	x=Rand(3,fieldsize-4)
	y=Rand(3,fieldsize-4)
	If map(x,y)=3 Or map(x,y)=4 Or map(x,y)=5
		For s.snake=Each snake
			If x<>s\x And y<>s\y
				map(x,y)=pear
			EndIf 
		Next
	EndIf 
End Function



Function load_res()

	AppTitle appname$+" - BCC #61 - ozzi789"
	Graphics 800,600,32,2
	SetBuffer BackBuffer()
	SeedRnd MilliSecs()
	
	ClsColor 69,146,69
	Cls

	timer=CreateTimer(30)
	gfx_cherry=LoadImage("gfx/cherry.png")
	gfx_pear=LoadImage("gfx/pear.png")
	gfx_grass =LoadImage("gfx/grass.png")
	gfx_grass2=LoadImage("gfx/grass2.png")
	gfx_grass3=LoadImage("gfx/grass3.png")
	gfx_wall=LoadImage("gfx/wall.png")
	
	gfx_background=LoadImage("gfx/background.png")
	gfx_mesg=LoadImage("gfx/mesg.png")	
	
	gfx_tail_w=LoadImage("gfx/tail_w.png")
	gfx_tail_s=LoadImage("gfx/tail_s.png")
	
	head(0)=LoadImage("gfx/head_d.png")
	head(1)=LoadImage("gfx/head_u.png")
	head(2)=LoadImage("gfx/head_l.png")
	head(3)=LoadImage("gfx/head_r.png")
	
	tail(0)=LoadImage("gfx/tail_r_u.png")
	tail(1)=LoadImage("gfx/tail_r_d.png")
	tail(2)=LoadImage("gfx/tail_l_d.png")
	tail(3)=LoadImage("gfx/tail_l_u.png")
	
	tailend(0)=LoadImage("gfx/tailend_u.png")
	tailend(1)=LoadImage("gfx/tailend_d.png")
	tailend(2)=LoadImage("gfx/tailend_r.png")
	tailend(3)=LoadImage("gfx/tailend_l.png")
	
	fontbig=(LoadFont("Arial",18,1,0,0))
	fontsmall=(LoadFont("Arial",12,1,0,0))
	
	
End Function 

Function reset_vars()
	player_start_x=0
	player_start_y=0
	map_time=-1
	map_time_total=-1
	score=0
	fruits_total=0
	map_score=-1
	dir=0
	old_dir=0
End Function

Function load_map(filename)
	Select gamemode
		Case 0
			mapfolder$="timetrial"
		Case 1
			mapfolder$="pointtrial"
		Case 2
			mapfolder$="classic"
		Default
			RuntimeError "Invalid gamemod- or map folder was changed!"
	End Select 
	full_filename$="maps\"+mapfolder$+"\"+filename+".map"
	file=OpenFile(full_filename$)

	If file=0 Then RuntimeError full_filename$+" not found"
	reset_vars()
		
	While Not Eof(file)
	   	strng$=ReadLine(file)
		
		If Not Left(strng$,1)="#" ;IGNORE COMMENTS
			sign1=Instr(strng$,",")
			sign2=Instr(strng$,",",sign1+1)
			strng_len%=Len(strng$)
			x=Left(strng$,sign1)
			y=Mid(strng$,sign1+1,strng_len%-sign1-strng_len%-sign2)
			p_typ$=Right(strng$,strng_len%-sign2)
			
			Select Lower(p_typ$)
				Case "block"
					map(x,y)=-1
				Case "snake"
					player_start_x=x
					player_start_y=y
				Case "time"
					map_time=x
				Case "grass"
					map(x,y)=3
				Case "grass2"
					map(x,y)=4
				Case "grass3"
					map(x,y)=5
				Case "score"
					map_score=x
			End Select
			
			If Instr(p_typ$,Lower("fruit")) >0 
				map(x,y)=Int(Right(p_typ$,1))
				fruits_total=fruits_total+1
			EndIf 
		EndIf 
			
	Wend 
	
	If player_start_x=0 And player_start_y=0 Then RuntimeError ("Error loading map, no player start was set!")
	
	spawn_snake(player_start_x,player_start_y)
	
	
	If map_time<>-1
		map_time_start=MilliSecs()	
		map_time_total=map_time
	Else If gamemode<>0
		spawn_fruit()
	EndIf 
	SetFont(fontbig)
	
	CloseFile(file)
	
End Function 




Function spawn_snake(x,y,f_dir=0)
	For del.snake=Each snake
		Delete del.snake
	Next
	s.snake=New snake
	s\x=x
	s\y=y
	s\sdir=f_dir
	dir=f_dir
End Function 


Function clean_snakes()
	snake_counter=0
	For s.snake=Each snake
		snake_counter=snake_counter+1
	Next

	If  snake_counter > snake_lenght 
		Delete First snake 
	EndIf 
End Function


Function check_borders()
	For s.snake = Each snake
		If s\x>fieldsize Then s\x=1
		If s\y>fieldsize Then s\y=1
		If s\x<1 Then s\x=fieldsize
		If s\y<1 Then s\y=fieldsize
	Next 
End Function




Function render()
	
	DrawImage gfx_background,0,0

	Select gamemode
		Case 0
			Text 600,20,"TIME: "+map_time
			Text 600,60,"FRUITS LEFT: "+fruits_total
			Text 600,100,"LEVEL: "+current_map
		Case 1
			Text 600,20,"SCORE: "+score+" / "+map_score
			Text 600,60,"LEVEL: "+current_map
		Case 2
			Text 600,20,"SCORE: "+score
	End Select 
	
	

	
	For x=1 To fieldsize
		For y=1 To fieldsize
			Select map(x,y)
				Case -1 ;BLOCK
					DrawImage gfx_wall,x*tilesize,y*tilesize
				Case 0 ; AIR
					DrawImage gfx_grass,x*tilesize,y*tilesize
				Case cherry
					DrawImage gfx_cherry,x*tilesize,y*tilesize
				Case 3
					DrawImage gfx_grass,x*tilesize,y*tilesize
				Case 4
					DrawImage gfx_grass2,x*tilesize,y*tilesize
				Case 5
					DrawImage gfx_grass3,x*tilesize,y*tilesize
				Case pear
					DrawImage gfx_pear,x*tilesize,y*tilesize
			End Select 
		Next
	Next 
	
	For s.snake=Each snake
		If s\sdir=0 Or s\sdir=1
			DrawImage gfx_tail_s,s\x*tilesize,s\y*tilesize
		ElseIf s\sdir=2 Or s\sdir=3
			DrawImage gfx_tail_w,s\x*tilesize,s\y*tilesize		
		ElseIf s\sdir=4
			DrawImage tail(0),s\x*tilesize,s\y*tilesize		
		ElseIf s\sdir=5
			DrawImage tail(1),s\x*tilesize,s\y*tilesize	
		ElseIf s\sdir=6
			DrawImage tail(2),s\x*tilesize,s\y*tilesize	
		ElseIf s\sdir=7
			DrawImage tail(3),s\x*tilesize,s\y*tilesize	
		EndIf 
	
	Next
	
	l.snake=Last snake
		DrawImage head(dir),l\x*tilesize,l\y*tilesize

	f.snake=First snake
	
		If f\sdir<4
			DrawImage tailend(f\sdir),f\x*tilesize,f\y*tilesize
		Else
			ttdir=f\sdir-4
			DrawImage tail(ttdir),f\x*tilesize,f\y*tilesize
		EndIf
			

	
	WaitTimer timer
	Flip 0
End Function 


Function check_for_fruit()
	For s.snake=Each snake
		fruit=map(s\x,s\y)
		If fruit=cherry
			map(s\x,s\y)=3
			fruits_total=fruits_total-1
			snake_lenght=snake_lenght+2
			Return 10
		EndIf
		If fruit=pear
			map(s\x,s\y)=3
			fruits_total=fruits_total
			snake_lenght=snake_lenght+2
			spawn_fruit()
			Return 1
		EndIf 
	Next
	Return 0
End Function


Function check_snake_collision(x,y)
	For s.snake = Each snake
			If (s\x=x And s\y=y) Or map(s\x,s\y)=-1 Then Return 1
	Next
	Return 0
End Function

Function keyboard()
	Local tdir=-1
	Local key_queue_counter
	
	key_queue_counter=0
	For k.key_queue = Each key_queue
		key_queue_counter=key_queue_counter+1
	Next

	If key_queue_counter<3	
		If KeyHit(200) Then tdir=1;OBEN
		If KeyHit(208) Then tdir=0;UNTEN
		If KeyHit(203) Then tdir=2;LINKS
		If KeyHit(205) Then tdir=3;RECHTS
		
		If dir=1 And tdir=0 Then Return
		If dir=0 And tdir=1 Then Return
		If dir=2 And tdir=3 Then Return
		If dir=3 And tdir=2 Then Return
		
		If tdir<>-1
			k.key_queue=New key_queue
				k\dir=tdir
		EndIf 
	EndIf 
End Function 


Function game_over(title$,winflag)
	FlushKeys()
	If winflag=1 Then current_map=current_map+1
	
	
	Select gamemode
	Case 0
		mapfolder$="timetrial"
	Case 1
		mapfolder$="pointtrial"
	Case 2
		mapfolder$="classic"
	Default
		RuntimeError "Invalid gamemod- or map folder was changed!"
	End Select 
	full_filename$="maps\"+mapfolder$+"\"+current_map+".map"
	file=OpenFile(full_filename$)
	If file =0 
		mappackover=1
		title$="Congratulations!"
		mpointer=0
		gamemode=2
		current_map=1
	EndIf 
	CloseFile(file)

	
	
	DrawImage gfx_mesg,200,250
	Text 300,280,title$,1,0
	If gamemode=2 Then	Text 300,300,"You made: "+score+" points!",1,0
	If mappackover=1 Then Text 300,320,"You finished the trial!",1,0 
	Flip
	WaitKey
	Delay(5)
	FlushKeys()
	If mappackover=1 Then Cls: Return
	
	

	load_map(current_map)
	spawn_snake(player_start_x,player_start_y)
	
End Function



Function move_snake()

	If MilliSecs()>growthtime+5000
		growthtime=MilliSecs()
		snake_lenght=snake_lenght+1
	EndIf 
	

	If MilliSecs()>last_move_time+200
		clean_snakes()	
		last_move_time=MilliSecs()
		f.key_queue=First key_queue
			If Handle(f)<>0
				lastdir=dir
				dir=f\dir
				Delete f.key_queue
			EndIf 
			
		;0=down,1=up,2=left,3=right
		If dir<>old_dir
			If (old_dir=0 And dir=2) Or (old_dir=3 And dir=1)
				l.snake= Last snake
				l\sdir=7
			EndIf
			
			If (old_dir=0 And dir=3) Or (old_dir=2 And dir=1)
				l.snake= Last snake
				l\sdir=4
			EndIf 
			
			If (old_dir=1 And dir=3) Or (old_dir=2 And dir=0)
				l.snake= Last snake
				l\sdir=5
			EndIf
			
			If (old_dir=3 And dir=0) Or (old_dir=1 And dir=2)
				l.snake= Last snake
				l\sdir=6
			EndIf 
			
		EndIf 		
	
		Select dir
			Case 0
				l.snake= Last snake
				If  check_snake_collision(l\x,l\y+1)   Then game_over("Ouch! You hit your head..",0) : Return 
				s.snake=New snake
					s\x=l\x
					s\y=l\y+1	
			Case 1
				l.snake= Last snake
				If  check_snake_collision(l\x,l\y-1)  Then game_over("Ouch! You hit your head..",0) : Return 
				s.snake=New snake
					s\x=l\x
					s\y=l\y-1	
			Case 2
				l.snake= Last snake
				If check_snake_collision(l\x-1,l\y)  Then game_over("Ouch! You hit your head..",0) : Return 
				s.snake=New snake
					s\x=l\x-1
					s\y=l\y	
			Case 3
				l.snake= Last snake
				If  check_snake_collision(l\x+1,l\y) Then game_over("Ouch! You hit your head..",0) : Return 
				s.snake=New snake
					s\x=l\x+1
					s\y=l\y
		End Select 
		
		s\sdir=dir
		old_dir=dir
		
		check_borders()
		collected=check_for_fruit()
		score=score+collected
	EndIf 
End Function 