
Function ButtonImg:Int(_img:TImage, _frame:Int, _x:Int, _y:Int)
	If MouseInRect(_x - _img.width / 2, _y - _img.height / 2, _img.width, _img.height)
		DrawImage(_img, _x, _y, _frame + 1) '* Hover Frame
		If mh1 Then
		 	Play_Sound(Snd_klick)
			Return True '* Mausklick berichten
		EndIf
	Else
		DrawImage(_img, _x, _y, _frame)	'* Inaktiver Frame
	EndIf
End Function

Function MouseInRect:Int(_x:Int, _y:Int, _w:Int, _h:Int)
	If mx <= _x Then Return False
	If my <= _y Then Return False
	If mx >= _x + _w Then Return False
	If my >= _y + _h Then Return False
	Return True	
End Function

Function PosInRect:Int(_px:Int, _py:Int, _x:Int, _y:Int, _w:Int, _h:Int)
	If _px <= _x Then Return False
	If _py <= _y Then Return False
	If _px >= _x + _w Then Return False
	If _py >= _y + _h Then Return False
	Return True	
End Function

Function DrawText(_txt:String, _x:Float, _y:Float, _HX:Float = 0.5, _HY:Float = 0.5)
	Local scale_X:Float, scale_Y:Float
	GetScale(scale_X, scale_Y)
	rem
		Extra INT casting gegen Bluring
	endrem
	brl.max2d.DrawText(_txt, Int(_x - (Float(TextWidth(_txt)) * scale_X * _HX)), Int(_y - (Float(TextHeight(_txt)) * scale_Y * _HY)))
End Function

Function MakeTime:String(_time:Int)
	'* _time [ms]
	Local parts:String[]
	
	'* Minuten
	If _time >= 60000 Then
		parts:+[String(_time / 60000)]
		_time = (_time Mod 60000)
	Else
		parts:+["0"]
	EndIf
	
	'* Sekunden
	If _time >= 1000 Then
		parts:+[String(_time / 1000)]
		If _time / 1000 < 10 Then parts[parts.Length - 1] = "0" + parts[parts.Length - 1]
		_time = (_time Mod 1000)
	Else
		parts:+["00"]
	EndIf
	
	Return ":".join(parts)
	
End Function

Function Play_Sound(_snd:TSound)
	If SoundOn Then
		Local chan:TChannel = PlaySound(_snd)
		chan.SetVolume(0.75)
	EndIf
End Function

Function AnAus:String(_value:Int)
	If _value Then
		Return "An"
	Else
		Return "Aus"
	EndIf
End Function
